var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { AbstractPowerSyncDatabase, SqliteBucketStorage } from '@journeyapps/powersync-sdk-common';
import { WebRemote } from './sync/WebRemote';
import { WebStreamingSyncImplementation } from './sync//WebStreamingSyncImplementation';
export class PowerSyncDatabase extends AbstractPowerSyncDatabase {
    _initialize() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
    generateBucketStorageAdapter() {
        return new SqliteBucketStorage(this.database, AbstractPowerSyncDatabase.transactionMutex);
    }
    generateSyncStreamImplementation(connector) {
        const remote = new WebRemote(connector);
        return new WebStreamingSyncImplementation({
            adapter: this.bucketStorageAdapter,
            remote,
            uploadCrud: () => __awaiter(this, void 0, void 0, function* () {
                yield this.waitForReady();
                yield connector.uploadData(this);
            }),
            retryDelayMs: this.options.retryDelay
        });
    }
}
//# sourceMappingURL=PowerSyncDatabase.js.map