import '@journeyapps/wa-sqlite';
import { QueryResult } from '@journeyapps/powersync-sdk-common';
export type WASQLExecuteResult = Omit<QueryResult, 'rows'> & {
    rows: {
        _array: any[];
        length: number;
    };
};
export type WASQLiteExecuteMethod = (sql: string, params?: any[]) => Promise<WASQLExecuteResult>;
export type OnTableChangeCallback = (opType: number, tableName: string, rowId: number) => void;
export type OpenDB = (dbFileName: string) => Promise<DBWorkerInterface>;
export type DBWorkerInterface = {
    execute: WASQLiteExecuteMethod;
    registerOnTableChange: (callback: OnTableChangeCallback) => void;
};
export type InternalDBWorkerInterface = DBWorkerInterface & {
    close: () => void;
};
